/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIDragSession.idl
 */

#ifndef __gen_nsIDragSession_h__
#define __gen_nsIDragSession_h__

#include "nsISupports.h"
#include "nsISupportsArray.h"
#include "nsITransferable.h"
#include "nsIDragTracker.h"

#include "nsSize.h"

/* starting interface:    nsIDragSession */
#define NS_IDRAGSESSION_IID_STR "cba22c53-fcce-11d2-96d4-0060b0fb9956"

#define NS_IDRAGSESSION_IID \
  {0xcba22c53, 0xfcce, 0x11d2, \
    { 0x96, 0xd4, 0x00, 0x60, 0xb0, 0xfb, 0x99, 0x56 }}

class nsIDragSession : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IDRAGSESSION_IID)

  /**
    * Set the current state of the drag whether it can be dropped or not.
    * usually the target "frame" sets this so the native system can render the correct feedback
    */
  /* attribute boolean canDrop; */
  NS_IMETHOD GetCanDrop(PRBool *aCanDrop) = 0;
  NS_IMETHOD SetCanDrop(PRBool aCanDrop) = 0;

  /**
    * Sets the action (copy, move, link, et.c) for the current drag 
    */
  /* attribute unsigned long dragAction; */
  NS_IMETHOD GetDragAction(PRUint32 *aDragAction) = 0;
  NS_IMETHOD SetDragAction(PRUint32 aDragAction) = 0;

  /**
    * Sets the current width and height if the drag target area. 
    * It will contain the current size of the Frame that the drag is currently in
    */
  /* [noscript] attribute nsSize targetSize; */
  NS_IMETHOD GetTargetSize(nsSize *aTargetSize) = 0;
  NS_IMETHOD SetTargetSize(nsSize aTargetSize) = 0;

  /**
    * Get the number items that were dropped
    */
  /* readonly attribute unsigned long numDropItems; */
  NS_IMETHOD GetNumDropItems(PRUint32 *aNumDropItems) = 0;

  /**
    * Get data from a Drag&Drop. Can be called while the drag is in process
    * or after the drop has completed.  
    *
    * @param  aTransferable the transferable for the data to be put into
    * @param  aItemIndex which of multiple drag items, zero-based
    */
  /* void getData (in nsITransferable aTransferable, in unsigned long aItemIndex); */
  NS_IMETHOD GetData(nsITransferable *aTransferable, PRUint32 aItemIndex) = 0;

  /**
    * Check to set if ant of the native data on the clipboard matches this data flavor
    *
    * @result NS_OK if if the data flavor is supported and, NS_ERROR_FAILURE is it is not
    */
  /* boolean isDataFlavorSupported (in string aDataFlavor); */
  NS_IMETHOD IsDataFlavorSupported(const char *aDataFlavor, PRBool *_retval) = 0;

  /**
    * Tell the session who needs to know when the drag completes so that it can 
    * stop tracking the mouse. There can be only one object tracking the drag at
    * a time.
    *
    * @param  aTracker - object who needs to know when tracking
    *                       should cease.
    */
  /* void startTracking (in nsIDragTracker aScroller); */
  NS_IMETHOD StartTracking(nsIDragTracker *aScroller) = 0;

  /**
    * Call to tell the object that is tracking the drag that it
    * can forget about it (mouse left the window or the drop completed).
    */
  /* void stopTracking (); */
  NS_IMETHOD StopTracking(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDRAGSESSION \
  NS_IMETHOD GetCanDrop(PRBool *aCanDrop); \
  NS_IMETHOD SetCanDrop(PRBool aCanDrop); \
  NS_IMETHOD GetDragAction(PRUint32 *aDragAction); \
  NS_IMETHOD SetDragAction(PRUint32 aDragAction); \
  NS_IMETHOD GetTargetSize(nsSize *aTargetSize); \
  NS_IMETHOD SetTargetSize(nsSize aTargetSize); \
  NS_IMETHOD GetNumDropItems(PRUint32 *aNumDropItems); \
  NS_IMETHOD GetData(nsITransferable *aTransferable, PRUint32 aItemIndex); \
  NS_IMETHOD IsDataFlavorSupported(const char *aDataFlavor, PRBool *_retval); \
  NS_IMETHOD StartTracking(nsIDragTracker *aScroller); \
  NS_IMETHOD StopTracking(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDRAGSESSION(_to) \
  NS_IMETHOD GetCanDrop(PRBool *aCanDrop) { return _to ## GetCanDrop(aCanDrop); } \
  NS_IMETHOD SetCanDrop(PRBool aCanDrop) { return _to ## SetCanDrop(aCanDrop); } \
  NS_IMETHOD GetDragAction(PRUint32 *aDragAction) { return _to ## GetDragAction(aDragAction); } \
  NS_IMETHOD SetDragAction(PRUint32 aDragAction) { return _to ## SetDragAction(aDragAction); } \
  NS_IMETHOD GetTargetSize(nsSize *aTargetSize) { return _to ## GetTargetSize(aTargetSize); } \
  NS_IMETHOD SetTargetSize(nsSize aTargetSize) { return _to ## SetTargetSize(aTargetSize); } \
  NS_IMETHOD GetNumDropItems(PRUint32 *aNumDropItems) { return _to ## GetNumDropItems(aNumDropItems); } \
  NS_IMETHOD GetData(nsITransferable *aTransferable, PRUint32 aItemIndex) { return _to ## GetData(aTransferable, aItemIndex); } \
  NS_IMETHOD IsDataFlavorSupported(const char *aDataFlavor, PRBool *_retval) { return _to ## IsDataFlavorSupported(aDataFlavor, _retval); } \
  NS_IMETHOD StartTracking(nsIDragTracker *aScroller) { return _to ## StartTracking(aScroller); } \
  NS_IMETHOD StopTracking(void) { return _to ## StopTracking(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsDragSession : public nsIDragSession
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIDRAGSESSION

  nsDragSession();
  virtual ~nsDragSession();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsDragSession, nsIDragSession)

nsDragSession::nsDragSession()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsDragSession::~nsDragSession()
{
  /* destructor code */
}

/* attribute boolean canDrop; */
NS_IMETHODIMP nsDragSession::GetCanDrop(PRBool *aCanDrop)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsDragSession::SetCanDrop(PRBool aCanDrop)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long dragAction; */
NS_IMETHODIMP nsDragSession::GetDragAction(PRUint32 *aDragAction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsDragSession::SetDragAction(PRUint32 aDragAction)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] attribute nsSize targetSize; */
NS_IMETHODIMP nsDragSession::GetTargetSize(nsSize *aTargetSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsDragSession::SetTargetSize(nsSize aTargetSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long numDropItems; */
NS_IMETHODIMP nsDragSession::GetNumDropItems(PRUint32 *aNumDropItems)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getData (in nsITransferable aTransferable, in unsigned long aItemIndex); */
NS_IMETHODIMP nsDragSession::GetData(nsITransferable *aTransferable, PRUint32 aItemIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isDataFlavorSupported (in string aDataFlavor); */
NS_IMETHODIMP nsDragSession::IsDataFlavorSupported(const char *aDataFlavor, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void startTracking (in nsIDragTracker aScroller); */
NS_IMETHODIMP nsDragSession::StartTracking(nsIDragTracker *aScroller)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void stopTracking (); */
NS_IMETHODIMP nsDragSession::StopTracking()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIDragSession_h__ */
