/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIMsgProtocolInfo.idl
 */

#ifndef __gen_nsIMsgProtocolInfo_h__
#define __gen_nsIMsgProtocolInfo_h__

#include "nsISupports.h"
#include "nsIFileSpec.h"

#define NS_MSGPROTOCOLINFO_PROGID_PREFIX \
  "component://netscape/messenger/protocol/info;type="

/* starting interface:    nsIMsgProtocolInfo */
#define NS_IMSGPROTOCOLINFO_IID_STR "53d0214a-689c-11d3-80f5-00a0c900d445"

#define NS_IMSGPROTOCOLINFO_IID \
  {0x53d0214a, 0x689c, 0x11d3, \
    { 0x80, 0xf5, 0x00, 0xa0, 0xc9, 0x00, 0xd4, 0x45 }}

class nsIMsgProtocolInfo : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMSGPROTOCOLINFO_IID)

  /**
     * the default path to store local data for this type of
     * server. Each server is usually in a subdirectory below this
     */
  /* attribute nsIFileSpec defaultLocalPath; */
  NS_IMETHOD GetDefaultLocalPath(nsIFileSpec * *aDefaultLocalPath) = 0;
  NS_IMETHOD SetDefaultLocalPath(nsIFileSpec * aDefaultLocalPath) = 0;

  /**
     * the IID of the protocol-specific interface for this server
     * usually used from JS to dynamically get server-specific attributes
     */
  /* readonly attribute nsIIDPtr serverIID; */
  NS_IMETHOD GetServerIID(nsIID * *aServerIID) = 0;

  /**
     * does this server type require a username?
     * for instance, news does not but IMAP/POP do
     */
  /* readonly attribute boolean requiresUsername; */
  NS_IMETHOD GetRequiresUsername(PRBool *aRequiresUsername) = 0;

  /**
     * if the pretty name of the server should
     * just be the e-mail address. Otherwise it usually
     * ends up being something like "news on hostname"
     */
  /* readonly attribute boolean preflightPrettyNameWithEmailAddress; */
  NS_IMETHOD GetPreflightPrettyNameWithEmailAddress(PRBool *aPreflightPrettyNameWithEmailAddress) = 0;

  /**
     * can this type of server be removed from the account manager?
     * for instance, local mail is not removable
     */
  /* readonly attribute boolean canDelete; */
  NS_IMETHOD GetCanDelete(PRBool *aCanDelete) = 0;

  /**
     * can you duplicate this server?
     * for instance, local mail is unique and should not be duplicated.
     */
  /* readonly attribute boolean canDuplicate; */
  NS_IMETHOD GetCanDuplicate(PRBool *aCanDuplicate) = 0;

  /**
     * Whether Fcc/Sent/etc should be on this server or
     * on a local server
    */
  /* readonly attribute boolean defaultCopiesAndFoldersPrefsToServer; */
  NS_IMETHOD GetDefaultCopiesAndFoldersPrefsToServer(PRBool *aDefaultCopiesAndFoldersPrefsToServer) = 0;

  /* readonly attribute long defaultServerPort; */
  NS_IMETHOD GetDefaultServerPort(PRInt32 *aDefaultServerPort) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMSGPROTOCOLINFO \
  NS_IMETHOD GetDefaultLocalPath(nsIFileSpec * *aDefaultLocalPath); \
  NS_IMETHOD SetDefaultLocalPath(nsIFileSpec * aDefaultLocalPath); \
  NS_IMETHOD GetServerIID(nsIID * *aServerIID); \
  NS_IMETHOD GetRequiresUsername(PRBool *aRequiresUsername); \
  NS_IMETHOD GetPreflightPrettyNameWithEmailAddress(PRBool *aPreflightPrettyNameWithEmailAddress); \
  NS_IMETHOD GetCanDelete(PRBool *aCanDelete); \
  NS_IMETHOD GetCanDuplicate(PRBool *aCanDuplicate); \
  NS_IMETHOD GetDefaultCopiesAndFoldersPrefsToServer(PRBool *aDefaultCopiesAndFoldersPrefsToServer); \
  NS_IMETHOD GetDefaultServerPort(PRInt32 *aDefaultServerPort); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMSGPROTOCOLINFO(_to) \
  NS_IMETHOD GetDefaultLocalPath(nsIFileSpec * *aDefaultLocalPath) { return _to ## GetDefaultLocalPath(aDefaultLocalPath); } \
  NS_IMETHOD SetDefaultLocalPath(nsIFileSpec * aDefaultLocalPath) { return _to ## SetDefaultLocalPath(aDefaultLocalPath); } \
  NS_IMETHOD GetServerIID(nsIID * *aServerIID) { return _to ## GetServerIID(aServerIID); } \
  NS_IMETHOD GetRequiresUsername(PRBool *aRequiresUsername) { return _to ## GetRequiresUsername(aRequiresUsername); } \
  NS_IMETHOD GetPreflightPrettyNameWithEmailAddress(PRBool *aPreflightPrettyNameWithEmailAddress) { return _to ## GetPreflightPrettyNameWithEmailAddress(aPreflightPrettyNameWithEmailAddress); } \
  NS_IMETHOD GetCanDelete(PRBool *aCanDelete) { return _to ## GetCanDelete(aCanDelete); } \
  NS_IMETHOD GetCanDuplicate(PRBool *aCanDuplicate) { return _to ## GetCanDuplicate(aCanDuplicate); } \
  NS_IMETHOD GetDefaultCopiesAndFoldersPrefsToServer(PRBool *aDefaultCopiesAndFoldersPrefsToServer) { return _to ## GetDefaultCopiesAndFoldersPrefsToServer(aDefaultCopiesAndFoldersPrefsToServer); } \
  NS_IMETHOD GetDefaultServerPort(PRInt32 *aDefaultServerPort) { return _to ## GetDefaultServerPort(aDefaultServerPort); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsMsgProtocolInfo : public nsIMsgProtocolInfo
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMSGPROTOCOLINFO

  nsMsgProtocolInfo();
  virtual ~nsMsgProtocolInfo();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsMsgProtocolInfo, nsIMsgProtocolInfo)

nsMsgProtocolInfo::nsMsgProtocolInfo()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsMsgProtocolInfo::~nsMsgProtocolInfo()
{
  /* destructor code */
}

/* attribute nsIFileSpec defaultLocalPath; */
NS_IMETHODIMP nsMsgProtocolInfo::GetDefaultLocalPath(nsIFileSpec * *aDefaultLocalPath)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsMsgProtocolInfo::SetDefaultLocalPath(nsIFileSpec * aDefaultLocalPath)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIIDPtr serverIID; */
NS_IMETHODIMP nsMsgProtocolInfo::GetServerIID(nsIID * *aServerIID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean requiresUsername; */
NS_IMETHODIMP nsMsgProtocolInfo::GetRequiresUsername(PRBool *aRequiresUsername)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean preflightPrettyNameWithEmailAddress; */
NS_IMETHODIMP nsMsgProtocolInfo::GetPreflightPrettyNameWithEmailAddress(PRBool *aPreflightPrettyNameWithEmailAddress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean canDelete; */
NS_IMETHODIMP nsMsgProtocolInfo::GetCanDelete(PRBool *aCanDelete)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean canDuplicate; */
NS_IMETHODIMP nsMsgProtocolInfo::GetCanDuplicate(PRBool *aCanDuplicate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean defaultCopiesAndFoldersPrefsToServer; */
NS_IMETHODIMP nsMsgProtocolInfo::GetDefaultCopiesAndFoldersPrefsToServer(PRBool *aDefaultCopiesAndFoldersPrefsToServer)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long defaultServerPort; */
NS_IMETHODIMP nsMsgProtocolInfo::GetDefaultServerPort(PRInt32 *aDefaultServerPort)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIMsgProtocolInfo_h__ */
