/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIPSMComponent.idl
 */

#ifndef __gen_nsIPSMComponent_h__
#define __gen_nsIPSMComponent_h__

#include "nsISupports.h"

class nsIPrincipal; /* forward declaration */

#include "cmtcmn.h"

/* starting interface:    nsIPSMComponent */
#define NS_IPSMCOMPONENT_IID_STR "9e482670-5412-11d3-bbc8-0000861d1237"

#define NS_IPSMCOMPONENT_IID \
  {0x9e482670, 0x5412, 0x11d3, \
    { 0xbb, 0xc8, 0x00, 0x00, 0x86, 0x1d, 0x12, 0x37 }}

class nsIPSMComponent : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPSMCOMPONENT_IID)

  /* [noscript] nsCMTControlStar getControlConnection (); */
  NS_IMETHOD GetControlConnection(CMT_CONTROL * *_retval) = 0;

  /**
   *  Display the Security Advisor.  PickledStatus and hostName can be null. 
   *  If they are, the "Selected Info" dialog will be empty.
   */
  /* void displaySecurityAdvisor (in string pickledStatus, in string hostName); */
  NS_IMETHOD DisplaySecurityAdvisor(const char *pickledStatus, const char *hostName) = 0;

  /**
   *  This will send PSM all preferences that we know about.
   */
  /* void passPrefs (); */
  NS_IMETHOD PassPrefs(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPSMCOMPONENT \
  NS_IMETHOD GetControlConnection(CMT_CONTROL * *_retval); \
  NS_IMETHOD DisplaySecurityAdvisor(const char *pickledStatus, const char *hostName); \
  NS_IMETHOD PassPrefs(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPSMCOMPONENT(_to) \
  NS_IMETHOD GetControlConnection(CMT_CONTROL * *_retval) { return _to ## GetControlConnection(_retval); } \
  NS_IMETHOD DisplaySecurityAdvisor(const char *pickledStatus, const char *hostName) { return _to ## DisplaySecurityAdvisor(pickledStatus, hostName); } \
  NS_IMETHOD PassPrefs(void) { return _to ## PassPrefs(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPSMComponent : public nsIPSMComponent
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPSMCOMPONENT

  nsPSMComponent();
  virtual ~nsPSMComponent();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPSMComponent, nsIPSMComponent)

nsPSMComponent::nsPSMComponent()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsPSMComponent::~nsPSMComponent()
{
  /* destructor code */
}

/* [noscript] nsCMTControlStar getControlConnection (); */
NS_IMETHODIMP nsPSMComponent::GetControlConnection(CMT_CONTROL * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void displaySecurityAdvisor (in string pickledStatus, in string hostName); */
NS_IMETHODIMP nsPSMComponent::DisplaySecurityAdvisor(const char *pickledStatus, const char *hostName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void passPrefs (); */
NS_IMETHODIMP nsPSMComponent::PassPrefs()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define PSM_COMPONENT_PROGID "component://netscape/psm"
#define PSM_COMPONENT_CLASSNAME "Mozilla PSM Component"

#endif /* __gen_nsIPSMComponent_h__ */
