/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIPipe.idl
 */

#ifndef __gen_nsIPipe_h__
#define __gen_nsIPipe_h__

#include "nsISupports.h"

class nsIPipe; /* forward declaration */

class nsIMemory; /* forward declaration */

class nsIBufferInputStream; /* forward declaration */

class nsIBufferOutputStream; /* forward declaration */


/* starting interface:    nsIPipeObserver */
#define NS_IPIPEOBSERVER_IID_STR "686b2d98-56c2-11d3-8cd4-0060b0fc14a3"

#define NS_IPIPEOBSERVER_IID \
  {0x686b2d98, 0x56c2, 0x11d3, \
    { 0x8c, 0xd4, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

class nsIPipeObserver : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPIPEOBSERVER_IID)

  /* void onFull (in nsIPipe pipe); */
  NS_IMETHOD OnFull(nsIPipe *pipe) = 0;

  /* void onWrite (in nsIPipe pipe, in unsigned long amount); */
  NS_IMETHOD OnWrite(nsIPipe *pipe, PRUint32 amount) = 0;

  /* void onEmpty (in nsIPipe pipe); */
  NS_IMETHOD OnEmpty(nsIPipe *pipe) = 0;

  /* void onClose (in nsIPipe pipe); */
  NS_IMETHOD OnClose(nsIPipe *pipe) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPEOBSERVER \
  NS_IMETHOD OnFull(nsIPipe *pipe); \
  NS_IMETHOD OnWrite(nsIPipe *pipe, PRUint32 amount); \
  NS_IMETHOD OnEmpty(nsIPipe *pipe); \
  NS_IMETHOD OnClose(nsIPipe *pipe); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPEOBSERVER(_to) \
  NS_IMETHOD OnFull(nsIPipe *pipe) { return _to ## OnFull(pipe); } \
  NS_IMETHOD OnWrite(nsIPipe *pipe, PRUint32 amount) { return _to ## OnWrite(pipe, amount); } \
  NS_IMETHOD OnEmpty(nsIPipe *pipe) { return _to ## OnEmpty(pipe); } \
  NS_IMETHOD OnClose(nsIPipe *pipe) { return _to ## OnClose(pipe); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeObserver : public nsIPipeObserver
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPEOBSERVER

  nsPipeObserver();
  virtual ~nsPipeObserver();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeObserver, nsIPipeObserver)

nsPipeObserver::nsPipeObserver()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsPipeObserver::~nsPipeObserver()
{
  /* destructor code */
}

/* void onFull (in nsIPipe pipe); */
NS_IMETHODIMP nsPipeObserver::OnFull(nsIPipe *pipe)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onWrite (in nsIPipe pipe, in unsigned long amount); */
NS_IMETHODIMP nsPipeObserver::OnWrite(nsIPipe *pipe, PRUint32 amount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onEmpty (in nsIPipe pipe); */
NS_IMETHODIMP nsPipeObserver::OnEmpty(nsIPipe *pipe)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onClose (in nsIPipe pipe); */
NS_IMETHODIMP nsPipeObserver::OnClose(nsIPipe *pipe)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipe */
#define NS_IPIPE_IID_STR "6c2c0146-56c2-11d3-8cd4-0060b0fc14a3"

#define NS_IPIPE_IID \
  {0x6c2c0146, 0x56c2, 0x11d3, \
    { 0x8c, 0xd4, 0x00, 0x60, 0xb0, 0xfc, 0x14, 0xa3 }}

class nsIPipe : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPIPE_IID)

  /* void initialize (in unsigned long segmentSize, in unsigned long maxSize, in nsIPipeObserver observer, in nsIMemory segmentAllocator); */
  NS_IMETHOD Initialize(PRUint32 segmentSize, PRUint32 maxSize, nsIPipeObserver *observer, nsIMemory *segmentAllocator) = 0;

  /* readonly attribute nsIBufferInputStream inputStream; */
  NS_IMETHOD GetInputStream(nsIBufferInputStream * *aInputStream) = 0;

  /* readonly attribute nsIBufferOutputStream outputStream; */
  NS_IMETHOD GetOutputStream(nsIBufferOutputStream * *aOutputStream) = 0;

  /* attribute nsIPipeObserver observer; */
  NS_IMETHOD GetObserver(nsIPipeObserver * *aObserver) = 0;
  NS_IMETHOD SetObserver(nsIPipeObserver * aObserver) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPE \
  NS_IMETHOD Initialize(PRUint32 segmentSize, PRUint32 maxSize, nsIPipeObserver *observer, nsIMemory *segmentAllocator); \
  NS_IMETHOD GetInputStream(nsIBufferInputStream * *aInputStream); \
  NS_IMETHOD GetOutputStream(nsIBufferOutputStream * *aOutputStream); \
  NS_IMETHOD GetObserver(nsIPipeObserver * *aObserver); \
  NS_IMETHOD SetObserver(nsIPipeObserver * aObserver); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPE(_to) \
  NS_IMETHOD Initialize(PRUint32 segmentSize, PRUint32 maxSize, nsIPipeObserver *observer, nsIMemory *segmentAllocator) { return _to ## Initialize(segmentSize, maxSize, observer, segmentAllocator); } \
  NS_IMETHOD GetInputStream(nsIBufferInputStream * *aInputStream) { return _to ## GetInputStream(aInputStream); } \
  NS_IMETHOD GetOutputStream(nsIBufferOutputStream * *aOutputStream) { return _to ## GetOutputStream(aOutputStream); } \
  NS_IMETHOD GetObserver(nsIPipeObserver * *aObserver) { return _to ## GetObserver(aObserver); } \
  NS_IMETHOD SetObserver(nsIPipeObserver * aObserver) { return _to ## SetObserver(aObserver); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipe : public nsIPipe
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPE

  nsPipe();
  virtual ~nsPipe();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipe, nsIPipe)

nsPipe::nsPipe()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsPipe::~nsPipe()
{
  /* destructor code */
}

/* void initialize (in unsigned long segmentSize, in unsigned long maxSize, in nsIPipeObserver observer, in nsIMemory segmentAllocator); */
NS_IMETHODIMP nsPipe::Initialize(PRUint32 segmentSize, PRUint32 maxSize, nsIPipeObserver *observer, nsIMemory *segmentAllocator)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIBufferInputStream inputStream; */
NS_IMETHODIMP nsPipe::GetInputStream(nsIBufferInputStream * *aInputStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIBufferOutputStream outputStream; */
NS_IMETHODIMP nsPipe::GetOutputStream(nsIBufferOutputStream * *aOutputStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIPipeObserver observer; */
NS_IMETHODIMP nsPipe::GetObserver(nsIPipeObserver * *aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipe::SetObserver(nsIPipeObserver * aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define NS_PIPE_DEFAULT_SEGMENT_SIZE    4096
#define NS_PIPE_DEFAULT_BUFFER_SIZE     (1024*1024)
extern NS_COM nsresult
NS_NewPipe(nsIBufferInputStream* *inStrResult,
           nsIBufferOutputStream* *outStrResult,
           nsIPipeObserver* observer = nsnull,
           PRUint32 segmentSize = NS_PIPE_DEFAULT_SEGMENT_SIZE,
           PRUint32 maxSize = NS_PIPE_DEFAULT_BUFFER_SIZE);

#endif /* __gen_nsIPipe_h__ */
