/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIWebProgress.idl
 */

#ifndef __gen_nsIWebProgress_h__
#define __gen_nsIWebProgress_h__

#include "nsISupports.h"

class nsIWebProgressListener; /* forward declaration */


/* starting interface:    nsIWebProgress */
#define NS_IWEBPROGRESS_IID_STR "570f39d0-efd0-11d3-b093-00a024ffc08c"

#define NS_IWEBPROGRESS_IID \
  {0x570f39d0, 0xefd0, 0x11d3, \
    { 0xb0, 0x93, 0x00, 0xa0, 0x24, 0xff, 0xc0, 0x8c }}

/**
 * The nsIWebProgress interface is used to look at the progress of a given 
 * browser loading.
 */
class nsIWebProgress : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IWEBPROGRESS_IID)

  enum { flag_net_start = 1 };

  enum { flag_net_stop = 2 };

  enum { flag_net_dns = 4 };

  enum { flag_net_connecting = 8 };

  enum { flag_net_redirecting = 16 };

  enum { flag_net_negotiating = 32 };

  enum { flag_net_transferring = 64 };

  enum { flag_net_failedDNS = 4096 };

  enum { flag_net_failedConnect = 8192 };

  enum { flag_net_failedTransfer = 16384 };

  enum { flag_net_failedTimeout = 32768 };

  enum { flag_net_userCancelled = 65536 };

  enum { flag_win_start = 1048576 };

  enum { flag_win_stop = 2097152 };

  /* void addProgressListener (in nsIWebProgressListener listener); */
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *listener) = 0;

  /* void removeProgressListener (in nsIWebProgressListener listener); */
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *listener) = 0;

  /* readonly attribute long progressStatusFlags; */
  NS_IMETHOD GetProgressStatusFlags(PRInt32 *aProgressStatusFlags) = 0;

  /* readonly attribute long curSelfProgress; */
  NS_IMETHOD GetCurSelfProgress(PRInt32 *aCurSelfProgress) = 0;

  /* readonly attribute long maxSelfProgress; */
  NS_IMETHOD GetMaxSelfProgress(PRInt32 *aMaxSelfProgress) = 0;

  /* readonly attribute long curTotalProgress; */
  NS_IMETHOD GetCurTotalProgress(PRInt32 *aCurTotalProgress) = 0;

  /* readonly attribute long maxTotalProgress; */
  NS_IMETHOD GetMaxTotalProgress(PRInt32 *aMaxTotalProgress) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIWEBPROGRESS \
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *listener); \
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *listener); \
  NS_IMETHOD GetProgressStatusFlags(PRInt32 *aProgressStatusFlags); \
  NS_IMETHOD GetCurSelfProgress(PRInt32 *aCurSelfProgress); \
  NS_IMETHOD GetMaxSelfProgress(PRInt32 *aMaxSelfProgress); \
  NS_IMETHOD GetCurTotalProgress(PRInt32 *aCurTotalProgress); \
  NS_IMETHOD GetMaxTotalProgress(PRInt32 *aMaxTotalProgress); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIWEBPROGRESS(_to) \
  NS_IMETHOD AddProgressListener(nsIWebProgressListener *listener) { return _to ## AddProgressListener(listener); } \
  NS_IMETHOD RemoveProgressListener(nsIWebProgressListener *listener) { return _to ## RemoveProgressListener(listener); } \
  NS_IMETHOD GetProgressStatusFlags(PRInt32 *aProgressStatusFlags) { return _to ## GetProgressStatusFlags(aProgressStatusFlags); } \
  NS_IMETHOD GetCurSelfProgress(PRInt32 *aCurSelfProgress) { return _to ## GetCurSelfProgress(aCurSelfProgress); } \
  NS_IMETHOD GetMaxSelfProgress(PRInt32 *aMaxSelfProgress) { return _to ## GetMaxSelfProgress(aMaxSelfProgress); } \
  NS_IMETHOD GetCurTotalProgress(PRInt32 *aCurTotalProgress) { return _to ## GetCurTotalProgress(aCurTotalProgress); } \
  NS_IMETHOD GetMaxTotalProgress(PRInt32 *aMaxTotalProgress) { return _to ## GetMaxTotalProgress(aMaxTotalProgress); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsWebProgress : public nsIWebProgress
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIWEBPROGRESS

  nsWebProgress();
  virtual ~nsWebProgress();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsWebProgress, nsIWebProgress)

nsWebProgress::nsWebProgress()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsWebProgress::~nsWebProgress()
{
  /* destructor code */
}

/* void addProgressListener (in nsIWebProgressListener listener); */
NS_IMETHODIMP nsWebProgress::AddProgressListener(nsIWebProgressListener *listener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeProgressListener (in nsIWebProgressListener listener); */
NS_IMETHODIMP nsWebProgress::RemoveProgressListener(nsIWebProgressListener *listener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long progressStatusFlags; */
NS_IMETHODIMP nsWebProgress::GetProgressStatusFlags(PRInt32 *aProgressStatusFlags)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long curSelfProgress; */
NS_IMETHODIMP nsWebProgress::GetCurSelfProgress(PRInt32 *aCurSelfProgress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long maxSelfProgress; */
NS_IMETHODIMP nsWebProgress::GetMaxSelfProgress(PRInt32 *aMaxSelfProgress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long curTotalProgress; */
NS_IMETHODIMP nsWebProgress::GetCurTotalProgress(PRInt32 *aCurTotalProgress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long maxTotalProgress; */
NS_IMETHODIMP nsWebProgress::GetMaxTotalProgress(PRInt32 *aMaxTotalProgress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIWebProgress_h__ */
